
package de.ivu.elect.business.ergebniskonflikt.boundary;

import javax.enterprise.context.RequestScoped;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;

import de.ivu.elect.business.ergebniskonflikt.entity.ErgebnisKonflikt;

@RequestScoped
@Named(ErgebnisKonfliktConversationSelect.COMPONENT_NAME)
public class ErgebnisKonfliktConversationSelect implements java.io.Serializable {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "ergebnisKonfliktConversationSelect";

  @Inject
  protected transient ErgebnisKonfliktExtendedDAO entityDAO;

  @Inject
  @ConversationGroup(ErgebnisKonfliktConversationStore.class)
  protected transient ErgebnisKonfliktConversationStore conversationStore;

  public ErgebnisKonfliktConversationSelect() {
    super();
  }

  public boolean isSelected() {
    return getEntityPK() != null;
  }

  public ErgebnisKonflikt getEntity() {
    return getEntityInternal();
  }

  private ErgebnisKonflikt getEntityInternal() {
    if (getEntityPK() == null) {
      return null;
    }

    return attach(getEntityPK());
  }

  public void setEntity(ErgebnisKonflikt entity) {
    setEntityAttached(attach(entity));
  }

  public void setEntity( de.ivu.elect.business.ergebniskonflikt.entity.ErgebnisKonfliktPK  pk) {
    setEntityAttached(attach(pk));
  }

  protected void setEntityAttached(ErgebnisKonflikt entity) {
    if(entity == null) {
      setEntityPK(null);
    } else {
      setEntityPK(entity.getPk());
    }
  }

  public
    de.ivu.elect.business.ergebniskonflikt.entity.ErgebnisKonfliktPK
   getEntityPK() {
    return conversationStore.getEntityPK();
  }

  public void setEntityPK(
    de.ivu.elect.business.ergebniskonflikt.entity.ErgebnisKonfliktPK
   entityPK) {
    conversationStore.setEntityPK(entityPK);
  }

  protected ErgebnisKonflikt attach(ErgebnisKonflikt entity) {
    if (entity == null){
      return null;
    }

    return attach(entity.getPk());
  }

  protected ErgebnisKonflikt attach( de.ivu.elect.business.ergebniskonflikt.entity.ErgebnisKonfliktPK  pk) {
    if (pk == null) {
      return null;
    }

    return entityDAO.findByPrimaryKey(pk);
  }

  public void clearEntity() {
    setEntityPK(null);

    conversationStore.close();
  }
}
